MCAmericanPathEngine< RNG > Class Template Reference
Pricing engines » Basket option engines

least-square Monte Carlo engine More...

`#include <ql/experimental/mcbasket/mcamericanpathengine.hpp>`

Inheritance diagram for MCAmericanPathEngine< RNG >:
[legend]

## Public Member Functions

| MCAmericanPathEngine (const ext::shared_ptr< StochasticProcessArray > &, Size timeSteps, Size timeStepsPerYear, bool brownianBridge, bool antitheticVariate, bool controlVariate, Size requiredSamples, Real requiredTolerance, Size maxSamples, BigNatural seed, Size nCalibrationSamples=Null< Size >())
Public Member Functions inherited from MCLongstaffSchwartzPathEngine< PathMultiAssetOption::engine, MultiVariate, PseudoRandom >
| MCLongstaffSchwartzPathEngine (const ext::shared_ptr< StochasticProcess > &process, Size timeSteps, Size timeStepsPerYear, bool brownianBridge, bool antitheticVariate, bool controlVariate, Size requiredSamples, Real requiredTolerance, Size maxSamples, BigNatural seed, Size nCalibrationSamples=Null< Size >())
void | calculate () const
Public Member Functions inherited from McSimulation< MultiVariate, PseudoRandom, Statistics >
result_type | value (Real tolerance, Size maxSamples=QL_MAX_INTEGER, Size minSamples=1023) const
| add samples until the required absolute tolerance is reached
result_type | valueWithSamples (Size samples) const
| simulate a fixed number of samples
result_type | errorEstimate () const
| error estimated using the samples simulated so far
const stats_type & | sampleAccumulator () const
| access to the sample accumulator for richer statistics
void | calculate (Real requiredTolerance, Size requiredSamples, Size maxSamples) const
| basic calculate method provided to inherited pricing engines

## Protected Member Functions

ext::shared_ptr< LongstaffSchwartzMultiPathPricer > | lsmPathPricer () const
Protected Member Functions inherited from MCLongstaffSchwartzPathEngine< PathMultiAssetOption::engine, MultiVariate, PseudoRandom >
virtual ext::shared_ptr< LongstaffSchwartzMultiPathPricer > | lsmPathPricer () const=0
TimeGrid | timeGrid () const
ext::shared_ptr< path_pricer_type > | pathPricer () const
ext::shared_ptr< path_generator_type > | pathGenerator () const
Protected Member Functions inherited from McSimulation< MultiVariate, PseudoRandom, Statistics >
| McSimulation (bool antitheticVariate, bool controlVariate)
virtual ext::shared_ptr< path_pricer_type > | controlPathPricer () const
virtual ext::shared_ptr< path_generator_type > | controlPathGenerator () const
virtual ext::shared_ptr< PricingEngine > | controlPricingEngine () const
virtual result_type | controlVariateValue () const

## Additional Inherited Members

Public Types inherited from MCLongstaffSchwartzPathEngine< PathMultiAssetOption::engine, MultiVariate, PseudoRandom >
typedef MultiVariate< PseudoRandom >::path_type | path_type
typedef McSimulation< MultiVariate, PseudoRandom, Statistics >::stats_type | stats_type
typedef McSimulation< MultiVariate, PseudoRandom, Statistics >::path_pricer_type | path_pricer_type
typedef McSimulation< MultiVariate, PseudoRandom, Statistics >::path_generator_type | path_generator_type
Public Types inherited from McSimulation< MultiVariate, PseudoRandom, Statistics >
typedef MonteCarloModel< MultiVariate, PseudoRandom, Statistics >::path_generator_type | path_generator_type
typedef MonteCarloModel< MultiVariate, PseudoRandom, Statistics >::path_pricer_type | path_pricer_type
typedef MonteCarloModel< MultiVariate, PseudoRandom, Statistics >::stats_type | stats_type
typedef MonteCarloModel< MultiVariate, PseudoRandom, Statistics >::result_type | result_type
Static Protected Member Functions inherited from McSimulation< MultiVariate, PseudoRandom, Statistics >
static Real | maxError (const Sequence &sequence)
static Real | maxError (Real error)
Protected Attributes inherited from MCLongstaffSchwartzPathEngine< PathMultiAssetOption::engine, MultiVariate, PseudoRandom >
ext::shared_ptr< StochasticProcess > | process_
const Size | timeSteps_
const Size | timeStepsPerYear_
const bool | brownianBridge_
const Size | requiredSamples_
const Real | requiredTolerance_
const Size | maxSamples_
const Size | seed_
const Size | nCalibrationSamples_
ext::shared_ptr< LongstaffSchwartzMultiPathPricer > | pathPricer_
Protected Attributes inherited from McSimulation< MultiVariate, PseudoRandom, Statistics >
ext::shared_ptr< MonteCarloModel< MultiVariate, PseudoRandom, Statistics > > | mcModel_
bool | antitheticVariate_
bool | controlVariate_

## Detailed Description

### template<class RNG = PseudoRandom>
class QuantLib::MCAmericanPathEngine< RNG >

least-square Monte Carlo engine

Warning:
  This method is intrinsically weak for out-of-the-money options.